/*
 * MathPlanner 3.1 - Mathematical design tool.
 * Copyright(C) 2002  Jarmo Nikkanen
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License with this program.
 *
 */

#ifndef _MATHPLANNER_CONFIG_READER_H
#define _MATHPLANNER_CONFIG_READER_H

#include <qstring.h>
#include <qcolor.h>
#include <qrect.h>

class DataStorage;


struct cfr_data {
      char  name[32];
      char  string[127];
      bool  save;
};


class config_file_reader {
      cfr_data *data;
      char     *rawdata;
      int      size,count;

			public:

      config_file_reader();
      ~config_file_reader();

      void Init();
      void CreateFile();

      DataStorage *Build();
      void Record(DataStorage *);
      void Load();
      void Save(QString);

      bool Match(int i,char *);
      bool Has(char *);

      int    Int(char *name);
      double  Double(char *name);
      QString  String(char *name);
      QRect Rect(char *name_v,char *name_h);
      QColor Color(char *name);

      void   SetInt(char *,int);
      void   SetString(char *,QString);
      void   SetColor(char *,QColor);

};

#endif

