/*
 * MathPlanner 3.1 - Mathematical design tool.
 * Copyright(C) 2002  Jarmo Nikkanen
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License with this program.
 *
 */

#ifndef _MATHPLANNER_ERROR_H
#define _MATHPLANNER_ERROR_H

#include <qstring.h>
#include <stdio.h>


#define TRACE printf("%s line:%u\n",__FILE__,__LINE__);
#define TRACE_QCOLOR(x) printf("%s line:%u  %u %u %u\n",__FILE__,__LINE__,x.red(),x.green(),x.blue());
#define TRACEP(x,y) printf("%s line:%u -- ",__FILE__,__LINE__,y); printf(x,y); printf("\n");
#define TRACET(x) printf("%s line:%u -- %s\n",__FILE__,__LINE__,x);

void Bug(char *c);
void Bug(char *c,int);
void Bug(char *c,double);
void Bug(long no);
void Bug(double no);
void BugHex(long no);
void Bug(char *c,double);

void ErrorReport(char *from,char *errorDetails,bool exit);
void ErrorReport(char *from,char *errorDetails);
void ErrorReport(char *from,QString);



//********* NEW BUG REPORT COMMANDS ************

void NBug(int,char *c);
void NBug(int,char *c,int);
void NBug(int,char *c,double);

void NBug(int,QString c);
void NBug(int,QString c,int);
void NBug(int,QString c,double);

void NBugReset();
void NBugEnd();

#endif


