/*
 * MathPlanner 3.0.1 - Mathematical design tool.
 * Copyright(C) 2002  Jarmo Nikkanen
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License with this program.
 *
 */



#include <malloc.h>
#include <stdio.h>
#include <qstringlist.h>

#include "Error.h"
#include "ServerHeaders.h"
#include "Object_string.h"
#include "Operators.h"



function_serv::function_serv()
{
int i;
space=25;
for(i=0;i<space;i++) function[i].string=NULL;
}   



QStringList function_serv::CreateFunctionList()
{

int i;
QStringList sl;

for(i=0;i<space;i++) {
   if (function[i].string) {
         sl.append(function[i].fname);
   }
}
return(sl);
}



int function_serv::FindEmptySlot()
{
int i;
for(i=0;i<space;i++) {
   if (function[i].string==NULL) return(i);
}
ErrorReport("FunctionServer","No more space for new functions");
return(-1);
}


int function_serv::FindFunction(QString name)
{
int i;
for(i=0;i<space;i++) {
   if (function[i].string)
   if (function[i].fname.compare(name)==0) return(i);
}
return(-1);
}


bool function_serv::GetPointer(QString name)
{
int no;
no=FindFunction(name);
if (no!=(-1)) return(function[no].pointer);
return(0);
}

string_object **function_serv::GetString(QString name)
{
int no;
no=FindFunction(name);
if (no!=(-1)) return(&function[no].string);
return(NULL);
}

function_defination_object *function_serv::GetFDO(QString name)
{
int no;
no=FindFunction(name);
if (no!=(-1)) return(function[no].fdo);
return(NULL);
}

int function_serv::GetCount(QString name)
{
int no;
no=FindFunction(name);
if (no!=(-1)) return(function[no].count);
return(1);
}




void function_serv::SetPointer(QString name,bool f)
{
int no;
no=FindFunction(name);
if (no!=(-1)) function[no].pointer=f;
}






//**** Add Function ****

// First Function

int function_serv::AddFunction(QString name,string_object *str,function_defination_object *fdo,int co)
{
int no;
no=FindFunction(name);
if (no==(-1)) no=FindEmptySlot();
if (no!=(-1)) {
   function[no].fname=name;
   function[no].string=str;
   function[no].fdo=fdo;
   function[no].count=co;
   function[no].pointer=false;
}
if (no==(-1)) ErrorReport("FunctionServer","AddFunction Failed");
return(no);
}



void function_serv::DeleteAllFunctions()
{
int i;
for(i=0;i<space;i++) {          // Name string is not deleted
   function[i].fname="";
   function[i].string=NULL;
   function[i].fdo=NULL;
   function[i].count=0;
}

// This looks terrible but we can do this becouse this function is marked as pointer
// and pointers are not loading string or fdo from server
// Non NULL values are required to overide NULL protection
i=AddFunction(QString("f"),(string_object *)0x1,(function_defination_object *)0x1,1);
SetPointer(QString("f"),true);

}



