/*
 * MathPlanner 3.1 - Mathematical design tool.
 * Copyright(C) 2002  Jarmo Nikkanen
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License with this program.
 *
 */

// TODO: Set private members

#include <stdio.h>
#include <qstring.h>
#include <qpoint.h>
#include <qtoolbar.h>
#include <qpixmap.h>
#include <qtoolbutton.h>
#include <qpopupmenu.h>
#include <qmenubar.h>
#include <qwhatsthis.h>
#include <qmainwindow.h>
#include <qmessagebox.h>
#include <qtooltip.h>
#include <qstatusbar.h>
#include <qscrollview.h>

#include "Extern.h"

class Paper;
class Message;
class ApplicationControl;
class DataStorage;	


class MathWindow : public QMainWindow
{
	Q_OBJECT
       	public:
       	MathWindow(QString doc);
       	virtual void resizeEvent ( QResizeEvent * );

       	void BuildMenu();

       	void Open(QString);
       	void Save(QString);
       	void Init();
        int  Style();
        QString Browser();

       	int  GetFreePage();
       	QPoint PaperPosition(int i);
       	class Paper *GetActivePaper();

        void      MessageReceived(DataStorage *msg,int rec);
        void      PostMessage(DataStorage *msg,int dest=TO_FRAME);

       	public slots:

        void FrameImage();
       	void FrameText();
       	void Calculate();
       	void Prefs();
        void Help();
       	void NewPage();
       	//void None();
       	void DeleteFunction();
       	void SelectNone();
       	void SelectAll();
       	void Copy();
       	void Cut();
       	void Paste();
       	void Print();
       	void Rescue();
       	void About();
       	void SaveCurrent();
       	void DragObject();
        void DropObject();
        void AddGraph();
        void SymbolSelected(int);
        void ImageEditor();
       	void Uusi();
        void Avaa();
        void Tallenna();
        void NextZoomFactor();
        void PrevZoomFactor();

       	public:
       	
       	QString ApplicationCaption;
       	QString CurrentDocumentName;
       	
        private:

        bool  DropDefaultImage;
       	int   Active_paper;
       	class Paper *paper[128];
      	
        QPixmap pm1,pm8,pm15,pm22;
				QPixmap pm2,pm9,pm16,pm23;
				QPixmap pm3,pm10,pm17,pm24;
				QPixmap pm4,pm11,pm18;
				QPixmap pm5,pm12,pm19;
				QPixmap pm6,pm13,pm20;
				QPixmap pm7,pm14,pm21;
		
				
				class ApplicationControl *AppControl;
				class DataStorage *datastore;	
				

				QToolButton *tb1,*tb2,*tb3,*tb4,*tb5,*tb6,*tb7;
				QToolButton *tb8,*tb9,*tb10,*tb11,*tb12,*tb13,*tb14;
				QToolButton *tb15,*tb16,*tb17,*tb18,*tb19,*tb20,*tb21,*tb22;
			
	
				QPopupMenu *pop1,*pop2,*pop3,*pop4,*pop5;
				QMenuBar *me;

	
				QWhatsThis *whats;
        QScrollView *scrollview;
       	QWidget *mainbox;
       	QToolBar *ToolBarB;
};


