/*
 * MathPlanner 3.1 - Mathematical design tool.
 * Copyright(C) 2002  Jarmo Nikkanen
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License with this program.
 *
 */

#ifndef _MATHPLANNER_MATH_CONTROL_H
#define _MATHPLANNER_MATH_CONTROL_H

#include <qfont.h>
#include <qcolor.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qstring.h>
#include <qaccel.h>
#include <qtoolbar.h>
#include <qpopupmenu.h>
#include <qtoolbutton.h>
#include <qpixmap.h>

#include "Extern.h"


class DataStorage;
class ApplicationControl;
class config_file_reader;





class MathControl : public QObject
{
	Q_OBJECT

       	public:
       	          MathControl(ApplicationControl *);		

        void      MessageReceived(DataStorage *msg,int rec);
        void      PostMessage(DataStorage *msg,int dest=TO_FRAME);


        private:

        void    Command(int);

        void    ControlBarSetup();
       	void    CreateOperatorBar();
        void    CreateComplexBar();

				void    SendFunctionStatus();


       	private slots:
       	
       	void Send(int);
       	void Send();
        void SetFont(int);
     	
       	// ------------------------------
       	void TPiiConst();
       	void TSqrt();
        void TDive();
        void TPower();
        void TLog();
	void Tln();
	void TExp();
	void Te();
	void TMin();
	void TMax();
	
	void TSin();
        void TCos();
        void TTan();
        void TCot();
        void TaSin();
        void TaCos();
        void TaTan();
        void TaCot();

        void TFact();
        void TFrac();
        void TInt();

        void TAbs();
	void TParA();
	void TParB();
	void TParC();
	
	void TSigma();
	void TPii();
	void TDef();
        void TDef2();
        void TDef3();

        void TImaginary();
	void TVectI();
	void TVectJ();
	void TVectK();

	void TArg();
	void TModul();
	void TRez();
	void TImz();
        void TCAng();

        void TVLen();
        void TVCross();
        void TConj();

        void TUnit();
        void TInteg();
        void TLoop();
	void TMatrix();



       	private:
        ApplicationControl *AppControl;
        config_file_reader *Prefs;

				QPixmap pm1,pm2,pm3;
				QPixmap pm4,pm5,pm6;						
				QToolButton *opr_b[50];
        QToolButton *opr_c[50];
				//QToolButton *tba1,*tba2;
				QToolButton *rational;
				QComboBox *expmodecombo,*fontsizecombo,*digitcount,*answercombo;
    		QToolBar *ControlBar,*OperatorBar,*ComplexBar;

};

#endif
