/*
 * MathPlanner 3.0 - Mathematical design tool.
 * Copyright(C) 2002  Jarmo Nikkanen
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License with this program.
 *
 */

#ifndef _MATHPLANNER_DISPLAY_H
#define _MATHPLANNER_DISPLAY_H

// DISPLAY REAL NUMBER *******************************
// ***************************************************

#include "Layout.h"
#include "MathHeaders.h"

class ApplicationControl;


class display {
			bool exp_display,show,value_overide,rational,hasout,hasoutb,hasroot,hasrootb,mark_a,mark_b;
      int exp_hi_limit, exp_low_limit;
      bool upper_only;

      class text_layout ValueLo, PiiLo, ValueLob, ValueLoc, ValueLod, ExpLo,MarkLo,MarkLob;
      class string_layout StrLo,StrLob,MainStr;
      class root_layout SqrtLo, SqrtLob;
      class dive_layout DiveLo;
      class exp_layout ExpLayout;

      layout_rect bounds;
      class ApplicationControl *AppControl;
      class string_object *string;
      mpl_rational_info info;

      public:
      display();

      void Init(ApplicationControl *ap,class string_object *);
      void SetNumber(double,int digits,int mode,QString mark,QString mark2,bool show_zero);
      bool SetRational(double real,QString mark,QString mark2,bool show_zero);
      layout_rect Bounds();
      void Draw(QPainter *);
      void SetPosition(QPoint pos);
      void SetValueOveride();
};

#endif




